/**
 * ./src/classes/ovary.d/merge.ts
 * penguins-eggs v.10.0.0 / ecmascript 2020
 * author: Piero Proietti
 * email: piero.proietti@gmail.com
 * license: MIT
 */
import Ovary from '../ovary.js';
/**
 * Ritorna true se c'è bisogno del mount --bind
 *
 * Ci sono tre tipologie:
 *
 * - normal solo la creazione della directory, nessun mount
 * - merged creazione della directory e mount ro
 * - mergedAndOverlay creazione directory, overlay e mount rw
 * - copied: creazione directory e copia
 */
export declare function merged(this: Ovary, dir: string): boolean;
/**
 * Restituisce true per le direcory da montare con overlay
 *
 * Ci sono tre tipologie:
 *
 * - normal solo la creazione della directory, nessun mount
 * - merged creazione della directory e mount ro
 * - mergedAndOverlay creazione directory, overlay e mount rw
 *
 * @param dir
 */
export declare function mergedAndOverlay(this: Ovary, dir: string): boolean;
